function DataProcTmr(obj,event,handles)      % This function is called by the   handles.CrrnCom.TimerFcn={'DataProcTmr', handles};
 % handles.CrrnCom.TimerPeriod=0.04;
global Snlb

if Snlb.TxOn==1     % time increase only when start
        Snlb.Time.S=Snlb.Time.S+toc;
        Snlb.t=[Snlb.t Snlb.Time.S];
        tic;  % reset time
        NRd=500;  % baudrate: 115200bit 11520byte, at 0.04 second 460 bytes will be tranmited.
else
    NRd=30;  % only control parameters
end

Snlb.Time.Ms=Snlb.Time.Ms+1;
if Snlb.Time.Ms >= 1/handles.CrrnCom.TimerPeriod  % update clock every second
    Snlb.Time.Ms=0;
    S=round(Snlb.Time.S);
    set(handles.TxtTmr,'string',[num2str(floor(S/3600)) ':' num2str(floor(S/60)) ':' num2str(mod(S,60))]);
end

Snlb.MTmrCnt=Snlb.MTmrCnt+1; % timer also used for text mode 
if Snlb.DataTrnsMd==0  % in text mode use DataProcTrmn
    return 
end
N=obj.BytesAvailable;

if( N<NRd)  % no enough data to read
    return
end
    Snlb.N=N;
    Snlb.BDataCrrn=fread(obj,NRd,'uint8');  % read the binary data;
    Indx=find(Snlb.BDataCrrn==0); % echo line begin with 0
    if isempty(Indx)==1     % 
        Snlb.BData=[Snlb.BData; Snlb.BDataCrrn]; Snlb.BRd=Snlb.BRd+1;
        return % no need to draw, teminate the function
    end
% Time=handles.CrrnCom.TimerPeriod=0.05;


%------  line seperator detected
RdBgn=1;
for i=1:length(Indx)    % one read may inlcude several line seperators
    if(Indx(i)>1)       % if the first data us line seperator, line completed
    Snlb.BData=[Snlb.BData; Snlb.BDataCrrn(RdBgn:(Indx(i)-1))];
    Snlb.BRd=Snlb.BRd+1;
    end
    if length(Snlb.BData) > 20
        NumPara=Snlb.BData;
        if (255 == NumPara(1))&&(1 == NumPara(2))&&(255 == NumPara(3))&&(2 == NumPara(4))  %control parameter found
            NumPara(1:4)=[];  %remove the identifier from data array
            %FrqnCntr*10,   PrfFpga/10,     PlsLngtFpga,    DpthStrt,       DpthTtl,
            %DcmtNmbr,      FfLngtH+1,      FfLngtL+1,      DataPntsH+1 ,   DataPntsL+1,    
            %PntsMode+1,    DataStrmEnbl+1, TxOn+1
            Snlb.f = NumPara(1)/10; Snlb.Prf = NumPara(2)*10;  Snlb.PlsLngt = NumPara(3);  Snlb.DpthStrt = NumPara(4); 
            Snlb.DpthStp = NumPara(5); Snlb.DcmtNmbr = NumPara(6); Snlb.FfLngt=(NumPara(7)-1)*256+NumPara(8)-1;  Snlb.Pnts = (NumPara(9)-1)*256+NumPara(10)-1;
            Snlb.PntsMode=NumPara(11)-1;Snlb.DataEnbl=NumPara(12)-1;
            set(handles.EdtF,'String',num2str(Snlb.f));              set(handles.EdtPrf,'String',num2str(Snlb.Prf));
            set(handles.EdtPlsLngt,'String',num2str(Snlb.PlsLngt));  set(handles.EdtDpthStrt,'String',num2str(Snlb.DpthStrt));
            set(handles.EdtDpthStp,'String',num2str(Snlb.DpthStp));  set(handles.EdtPnts,'String',num2str(Snlb.Pnts));
            set(handles.TxtPnt,'String',[num2str(Snlb.FfLngt) ' Bytes Digitized']);
            set(handles.ChckFx, 'value',Snlb.PntsMode);   %when the total data point is changed, automatically set the fixed point mode.    

            if Snlb.DataEnbl == 1
                set(handles.BttnDataEnbl,'string','Stop Data');
            else
                set(handles.BttnDataEnbl,'string','Start Data');
            end
%             if (NumPara(13)-1) == 1     % Board in TxOn mode
%                 if Snlb.TxOn==0     % Matlab in Stop mode
%                     Snlb.TxOn=1;
%                     set(handles.BttnStrt,'String','Stop');set(handles.BttnStrt,'ForegroundColor','r');
%                     Snlb.CrcErr=0;
%                     Snlb.MTmrCnt=0; % timer also used for text mode
%                     Snlb.MTimeSet=0;     % 1 M-mode time information set, clear after each start, or mode, depth, parameter change.
%                     tic;    %save system time
%                 end    
%             else                % Board in TxOff mode
%                 if Snlb.TxOn==1     % Matlab in Start mode
%                     Snlb.TxOn=0;
%                     set(handles.BttnStrt,'String','Start');set(handles.BttnStrt,'ForegroundColor',[0 0.498 0]);
%                 end    
%             end
            %-------Update TGC
            Snlb.TGC1=NumPara(14:25)-1;  % TGC1Lvl, TGC1Slp Data...
            N=length(Snlb.TGC1);
            set(handles.SldrGain,'value',Snlb.TGC1(1)); set(handles.SldrTgc,'value',Snlb.TGC1(2));
            XLbl = (1:(N-3))/(N-3)*(Snlb.DpthStp - Snlb.DpthStrt) + Snlb.DpthStrt; 
            plot(handles.AxTgc,XLbl,Snlb.TGC1(3:N-1));axis(handles.AxTgc,'tight');ylim(handles.AxTgc, [ 0 255]);
            xlabel(handles.AxTgc,'Depth: mm'); title(handles.AxTgc,'TGC');
        else
        if Snlb.TxOn==1     %update curves only when started
        GrphUpdt(handles);
        end
        end
    end

    RdBgn=Indx(i)+1;
    Snlb.BData=[]; Snlb.BRd=0;    % prepare for the next line seperator in the current reading.
end
Snlb.BData=Snlb.BDataCrrn(RdBgn:length(Snlb.BDataCrrn));  %If RdBgn > length,  BData is empty
Snlb.BRd=1;        





